/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"

// renvoie l'indice de début d'une occurrence du motif `m` dans le texte `t`,
// ou -1 s'il n'y a pas d'occurrence
int naive_search(char *m, char *t);

// compte le nombre d'occurrences du motif `m` dans le texte `t`
int count_occurrences(char *m, char *t);

// renvoie la longueur de la plus longue séquence ininterrompue
// d'un même caractère
int longest_repetition(char *t);

// `t` est-il un palindrome ?
bool palindrome(char *t);

// renvoie la longueur du plus long palindrome de `t`
int longest_palindrome(char *t);

// renvoie la longueur du plus long palindrome de `t`
int manacher_longest_palindrome(char *t);
